# Supported algorithms

ACL aims to support a few core algorithms that are well suited for production use and other algorithms that are interesting to compare against.

*  [Uniformly sampled](algorithm_uniformly_sampled.md)

# How to integrate the library

*  [Handling asserts](handling_asserts.md)
*  [Implementing an allocator](implementing_an_allocator.md)
*  [Creating a raw track list](creating_a_raw_track_list.md)
*  [Pre-processing a raw track list](pre_processing_raw_tracks.md)
*  [Compressing tracks](compressing_raw_tracks.md)
*  [Decompressing tracks](decompressing_a_track_list.md)
*  [Handling looping playback](handling_looping_playback.md)
*  [Handling per track rounding](handling_per_track_rounding.md)
*  [Database and streaming support](database_support.md)
*  [Other considerations](misc_integration_details.md)
*  [Migrating from an earlier ACL version](migrating.md)

See how it's integrated into Unreal Engine 4 [here](https://github.com/nfrechette/acl-ue4-plugin)!

# Performance metrics

*  [Carnegie-Mellon University database performance](cmu_performance.md)
*  [Paragon database performance](paragon_performance.md)
*  [Matinee fight scene performance](fight_scene_performance.md)
*  [Decompression performance](decompression_performance.md)

# Research

*  [Arithmetic accuracy](research_arithmetic_accuracy.md)

# Miscellaneous

*  [The ACL file format](the_acl_file_format.md)
*  [Rotation and vector formats](rotation_and_vector_formats.md)
*  [Range reduction](range_reduction.md)
*  [Error metrics](error_metrics.md)
*  [Performance graph generation](graph_generation.md)
